#ifdef LINUX
#include <stdio.h>
#include <string.h>  /* memcpy */
#include <sys/ioctl.h>
#include <errno.h>

#define err_exit(z) \
	fprintf(stderr, "errno:%d %s\n", errno, \
	(errno > 0 && errno < sys_nerr ? sys_errlist[errno] : "")), exit(z)

/******************************************************************************
$B!Z4X?tL>![(B	getch
$B!Z5!!!G=![(B	getch() $B$N%(%_%e%l!<%H!#(B
$B!Z0z!!?t![(B	$B$J$7!#(B
$B!ZLa$jCM![(B	$BF~NO$5$l$?J8;z!#(B
$B!Z!D!D!D![(B  ...
******************************************************************************/
int getch(void)
{
  struct termio  tbuf;
  struct termio  save_tbuf;
  char  ch;
 
  fflush(stdout);
  // $BI8=`F~NO$N@)8f(B
  if (ioctl(0, TCGETA, &tbuf) == -1) {
	err_exit(1);
  }
  save_tbuf = tbuf;
  tbuf.c_lflag &= ~ICANON;
  tbuf.c_lflag &= ~ECHO;

  if (ioctl(0, TCSETAW, &tbuf) == -1) {
	err_exit(1);
  }

  if (read(0, &ch, 1) == -1) {
	err_exit(1);
  } 

  // $B85$KLa$9(B
  if (ioctl(0, TCSETAW, &save_tbuf) == -1) {
	err_exit(1);
  }
  return (int)ch;

/***
  int ch;
  switch(ch = getchar()) {
  case '\033':
  case '[':
	return ch;
  default:
	putchar('\010');
	return ch;
  }
***/
}

/******************************************************************************
$B!Z4X?tL>![(B	kbhit
$B!Z5!!!G=![(B	kbhit() $B$N%(%_%e%l!<%H!#(B
$B!Z0z!!?t![(B	$B$J$7!#(B
$B!ZLa$jCM![(B	0 $B$+(B 1
$B!Z!D!D!D![(B	...
******************************************************************************/
int kbhit(void)
{
  return 0;
}
#endif /* LINUX */


